"use strict";

////////////////////////////////////////////////////////////////
/** @fileOverview Performance testing toolkit. */
////////////////////////////////////////////////////////////////

/* Invoce 'fn' function 'n' times with 'this' set to 'ctx'.
 * Use 'ctx' to initialise test and to pass state between calls. */
function perf(msg, fn, n, ctx) {
    if (typeof n !== "number" || n < 1)
        n = 1;
    var tsFrom = new Date().getTime();
    for (i = 0; i < n; i++)
        fn.call(ctx);
    var tsTo = new Date().getTime();
    console.log(msg + ": %f ms, %d u/s", tsTo-tsFrom, i/(tsTo - tsFrom)*1000);
}

